<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Tutorial &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/doctools.js"></script>
        <script src="_static/sphinx_highlight.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Grid" href="grid.html" />
    <link rel="prev" title="Installation" href="installation.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Tutorial</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#loading-the-package">Loading the package</a></li>
<li class="toctree-l2"><a class="reference internal" href="#initializing-the-physical-problem">Initializing the physical problem</a></li>
<li class="toctree-l2"><a class="reference internal" href="#initializing-the-system">Initializing the system</a></li>
<li class="toctree-l2"><a class="reference internal" href="#running-the-simulation">Running the simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="#visualizing-the-results">Visualizing the results</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="grid.html">Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="physical_problem.html">Physical Problem</a></li>
<li class="toctree-l1"><a class="reference internal" href="integrator.html">Integrator</a></li>
<li class="toctree-l1"><a class="reference internal" href="system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Tutorial</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/tutorial.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="tutorial">
<h1>Tutorial<a class="headerlink" href="#tutorial" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line">In this tutorial we want to learn how to use this package.</div>
<div class="line">This is explained in the case of a lid-driven cavity flow.</div>
</div>
<div class="line-block">
<div class="line">For reference regarding the installation have a look at the <a class="reference internal" href="installation.html#installation"><span class="std std-ref">Installation</span></a></div>
</div>
<section id="loading-the-package">
<h2>Loading the package<a class="headerlink" href="#loading-the-package" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">First, one needs to import the package.</div>
<div class="line">This can be done with</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">cflowpy</span> <span class="k">as</span> <span class="nn">cf</span>
</pre></div>
</div>
</section>
<section id="initializing-the-physical-problem">
<h2>Initializing the physical problem<a class="headerlink" href="#initializing-the-physical-problem" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">Next, we need to specify the physical problem in order
of boundary conditions.</div>
<div class="line">In this example we want to simulate a Cavity flow, so we use the
the class <code class="docutils literal notranslate"><span class="pre">Cavity_flow</span></code> for specifying this.</div>
<div class="line">We want to have a flow on top of the domain from left to right
with a velocity of one.</div>
<div class="line">This we can initialize with:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem_cavity</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">Cavity_flow</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;top&quot;</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="initializing-the-system">
<h2>Initializing the system<a class="headerlink" href="#initializing-the-system" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">In this example we use a Grid on the domain (0,2) in x-direction
and (0,2) in y-direction.</div>
<div class="line">In this case we want to simulate water with a kinematic viscosity of
0.1[mm^2/s] and 1[kg/L] for the density.</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">system</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">System</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">30</span><span class="p">,</span>
<span class="go">                       0, 2, 30,</span>
<span class="go">                       0.1, 1,</span>
<span class="go">                       physical_problem_cavity)</span>
</pre></div>
</div>
</section>
<section id="running-the-simulation">
<h2>Running the simulation<a class="headerlink" href="#running-the-simulation" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">Now we start the simulation with a time step length of 0.001
and stop after 3 seconds</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="mf">0.01</span><span class="p">,</span> <span class="mi">5</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="visualizing-the-results">
<h2>Visualizing the results<a class="headerlink" href="#visualizing-the-results" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">We can use the Visualizing routine from cflowpy with
the maplotlib colormap “coolwarm”</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span> <span class="n">fig</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">contourfigure</span><span class="p">(</span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span>
<span class="go">                                cmap=&quot;coolwarm&quot;,</span>
<span class="go">                                title=&quot;Lid-driven cavity flow&quot;)</span>
</pre></div>
</div>
<a class="reference internal image-reference" href="_images/Cavity_quiver.png"><img alt="_images/Cavity_quiver.png" src="_images/Cavity_quiver.png" style="width: 600px;" /></a>
<div class="line-block">
<div class="line">To get a contourfigure where the pressure is visualized with
a colormap and the velocity visualized as arrows.</div>
<div class="line">If one wants to get streamlines instead of the velocity field,
it is possible to use the optional argument <code class="docutils literal notranslate"><span class="pre">velocity</span></code> as “streamline”</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">fig</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">contourfigure</span><span class="p">(</span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span>
<span class="go">                               velocity=&quot;streamline&quot;,</span>
<span class="go">                               cmap=&quot;coolwarm&quot;,</span>
<span class="go">                               title=&quot;Lid-driven cavity flow&quot;)</span>
</pre></div>
</div>
<a class="reference internal image-reference" href="_images/Cavity_streamline.png"><img alt="_images/Cavity_streamline.png" src="_images/Cavity_streamline.png" style="width: 600px;" /></a>
<div class="line-block">
<div class="line">Now we would like to create a gif to visualize the velocities
and the pressure over time.</div>
<div class="line">Therefore, we can use the <code class="docutils literal notranslate"><span class="pre">`create_gif`</span></code> routine and save the gif
in the “example.gif” file.</div>
<div class="line">We only want to visualize every 10th time step and want each frame
to last for 5ms.</div>
<div class="line">However, to do so we need to get the history of the velocities and
the pressure over time and rerun the simulation with the <code class="docutils literal notranslate"><span class="pre">`history`</span></code> argument set to true.</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span> <span class="o">=</span> <span class="n">system_cavity</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="mf">0.001</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="n">history</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">fig</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">create_gif</span><span class="p">(</span><span class="s2">&quot;example.gif&quot;</span><span class="p">,</span>
<span class="go">                            u, v, p,</span>
<span class="go">                            velocity=&quot;streamline&quot;,</span>
<span class="go">                            cmap=&quot;coolwarm&quot;,</span>
<span class="go">                            skip_time=10, duration=5,</span>
<span class="go">                            title=&quot;Lid-driven cavity flow&quot;)</span>
</pre></div>
</div>
<figure class="align-center">
<a class="reference internal image-reference" href="_images/Cavity.gif"><img alt="StreamPlayer" src="_images/Cavity.gif" style="width: 600px;" /></a>
</figure>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="installation.html" class="btn btn-neutral float-left" title="Installation" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="grid.html" class="btn btn-neutral float-right" title="Grid" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>